<?php

namespace Tests\Feature\Category;

use App\Models\Category;
use App\Models\User;
use Illuminate\Foundation\Testing\RefreshDatabase;
use Illuminate\Foundation\Testing\WithFaker;
use Tests\TestCase;

class ListTest extends TestCase
{
    use RefreshDatabase, WithFaker;

    public function test_guest_user_cannot_access_list(): void
    {
        $response = $this->getJson(route('categories.list'));
        $response->assertUnauthorized();
    }
    public function test_user_can_see_list(): void
    {
        $user = User::factory()->create();
        $response = $this->actingAs($user)->getJson(route('categories.list'));

        Category::factory()->count(3)->create();

        $response->assertOk();
        $response->assertJsonStructure([
            'data' => [
                '*' => [
                    'id',
                    'category_id',
                    'category_name',
                    'subcategory_id',
                    'subcategory_name'
                ],
            ]
        ]);

    }
}
